import { useRef } from 'react';
import { depsSame } from "../utils";
/**
 * 代替useRef useMemo useCallback的缓存依赖钩子
 * @param factory
 * @param deps
 * @returns
 */

export default function useCreate(factory, deps) {
  var _useRef = useRef({
    deps: deps,
    data: undefined,
    isFirstRender: true
  }),
      current = _useRef.current;

  if (current.isFirstRender || !depsSame(current.deps, deps)) {
    current.deps = deps;
    current.data = factory();
    current.isFirstRender = false;
  }

  return current.data;
}