import { useCallback, useRef } from 'react';
/**
 * 持久函数,地址永远不会改变
 * @param fn
 * @returns
 */

function usePersistFn(fn) {
  var ref = useRef(fn);
  ref.current = fn;
  var persistFn = useCallback(function () {
    var refFn = ref.current;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return refFn === null || refFn === void 0 ? void 0 : refFn.apply(void 0, args);
  }, [ref]);
  return persistFn;
}

export default usePersistFn; //  https://zh-hans.reactjs.org/docs/hooks-faq.html#how-to-read-an-often-changing-value-from-usecallback
// function useEventCallback(fn, dependencies) {
//   const ref = useRef(() => {
//     throw new Error('Cannot call an event handler while rendering.');
//   });
//   useEffect(() => {
//     ref.current = fn;
//   }, [fn, ...dependencies]);
//   return useCallback(() => {
//     const fn = ref.current;
//     return fn();
//   }, [ref]);
// }