"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useCreate;

var _react = require("react");

var _utils = require("../utils");

/**
 * 代替useRef useMemo useCallback的缓存依赖钩子
 * @param factory
 * @param deps
 * @returns
 */
function useCreate(factory, deps) {
  const {
    current
  } = (0, _react.useRef)({
    deps,
    data: undefined,
    isFirstRender: true
  });

  if (current.isFirstRender || !(0, _utils.depsSame)(current.deps, deps)) {
    current.deps = deps;
    current.data = factory();
    current.isFirstRender = false;
  }

  return current.data;
}